/* Created by Anjuta version 0.9.99 */
/*	This file will not be overwritten */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <include/tanimlar.h>
#include <include/tablolar.h>

#define MAXSTR 100

char Zamanlar[12][12]={
	"Present",
	"Imparfait",
	"FSimple",
	"PCompose",
	"PParfait",
	"FAnterieur",
	"SPasse",
	"CPasse",
	"SPresent",
	"CPresent",
	"Imperatif",
	"PSimple",
};

int KokBul( char *verbe, int sil, char *kok );
int Present(char *verbe, struct cekim_struct *cekim);
int Imparfait(char *verbe, struct cekim_struct *cekim);
int FSimple(char *verbe, struct cekim_struct *cekim);
int SPresent(char *verbe, struct cekim_struct *cekim);
int CPresent(char *verbe, struct cekim_struct *cekim);	
int Imperatif(char *verbe, struct cekim_struct *cekim);
int PSimple(char *verbe, struct cekim_struct *cekim);
int TempsCompose(char *verbe, struct cekim_struct *auxiliare, struct cekim_struct *cekim);
int PCompose(char *verbe, struct cekim_struct *cekim);
int PParfait(char *verbe, struct cekim_struct *cekim);
int FAnterieur(char *verbe, struct cekim_struct *cekim);
int SPasse(char *verbe, struct cekim_struct *cekim);
int CPasse(char *verbe, struct cekim_struct *cekim);

int Kes(char *suj, char *kisi);
int CekimBul(char *verbe);
void cekimyaz(struct cekim_struct *cekim);
void birlestir(char *sujet, char *kok, char *ara, char *ek, char *kisi);

int ( *cekimler[12] ) ( char *verbe, struct cekim_struct *cekim );
void usage(char *progname);

int main(int argc, char *argv[])
{
	int i, ok=0;
	struct cekim_struct cekim;
	
	if( argc==1 ) usage(argv[0]);
		
	cekimler[0]=Present;
    cekimler[1]=Imparfait;
    cekimler[2]=FSimple;
    cekimler[3]=PCompose;
    cekimler[4]=PParfait;
    cekimler[5]=FAnterieur;
    cekimler[6]=SPasse;
    cekimler[7]=CPasse;
    cekimler[8]=SPresent;
    cekimler[9]=CPresent;
    cekimler[10]=Imperatif;
    cekimler[11]=PSimple;
	
	for( i=0; i<12; i++) {
		if( !strcasecmp(argv[2], Zamanlar[i]) ) {
			cekimler[i]( argv[1], &cekim );
			cekimyaz(&cekim); ok=1; break;
		}
	}
	if( !ok ) usage(argv[0]);
	
	return (0);
}

void usage(char *progname)
{
	int i;
	puts("Bu program verilen fiilin verilen zamanda Fransizca cekimini yapar.\n");
	for(i=0; i<12; i+=4) 
		printf("%s, %s, %s, %s\n", Zamanlar[i], Zamanlar[i+1], Zamanlar[i+2], Zamanlar[i+3]);
		
	printf("usage:%s fiil zaman\n", progname);
	puts("Ali BASEL 2002\n");
	exit(1);
}

void cekimyaz(struct cekim_struct *cekim)
{
	int i;
	
	for(i=0; i<8; i++) {
		printf("%s\n", cekim->kisiler[i]);
	}
}

int Present(char *verbe, struct cekim_struct *cekim)
{
    char suj[MAXSTR], kok[MAXSTR], ek[MAXSTR];
	int verbeno=-1;
	
    //ekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    KokBul(verbe, tablo[verbeno].pr_je_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_je_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "je");
	birlestir(suj, kok, tablo[verbeno].pr_je_ara, ek, cekim->kisiler[0]);
	
	                    /* tu */
	KokBul(verbe, tablo[verbeno].pr_tu_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_tu_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "tu ");
	birlestir(suj, kok, tablo[verbeno].pr_tu_ara, ek, cekim->kisiler[1]);
		    
                        /* il elle*/
	KokBul(verbe, tablo[verbeno].pr_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_il_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "il ");
	birlestir(suj, kok, tablo[verbeno].pr_il_ara, ek, cekim->kisiler[2]);

	KokBul(verbe, tablo[verbeno].pr_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_il_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "elle ");
	birlestir(suj, kok, tablo[verbeno].pr_il_ara, ek, cekim->kisiler[3]);
		
                        /* nous */
	KokBul(verbe, tablo[verbeno].pr_nous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_nous_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "nous ");
	birlestir(suj, kok, tablo[verbeno].pr_nous_ara, ek, cekim->kisiler[4]);
    
              /* vous */
	KokBul(verbe, tablo[verbeno].pr_vous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_vous_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "vous ");
	birlestir(suj, kok, tablo[verbeno].pr_vous_ara, ek, cekim->kisiler[5]);
    
              /* ils elles*/
	KokBul(verbe, tablo[verbeno].pr_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_ils_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "ils ");
	birlestir(suj, kok, tablo[verbeno].pr_ils_ara, ek, cekim->kisiler[6]);
    
	KokBul(verbe, tablo[verbeno].pr_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].pr_ils_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "elles ");
	birlestir(suj, kok, tablo[verbeno].pr_ils_ara, ek, cekim->kisiler[7]);
	
	return 1;
}


int Imparfait(char *verbe, struct cekim_struct *cekim)
{
    char suj[10], kok[MAXSTR], ek[MAXSTR];
	int verbeno=-1;
	
    //cekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    KokBul(verbe, tablo[verbeno].im_je_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_je_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "je");
	birlestir(suj, kok, tablo[verbeno].im_je_ara, ek, cekim->kisiler[0]);
        
	                    /* tu */
	KokBul(verbe, tablo[verbeno].im_tu_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_tu_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "tu ");
	birlestir(suj, kok, tablo[verbeno].im_tu_ara, ek, cekim->kisiler[1]);
	    
                        /* il elle*/
	KokBul(verbe, tablo[verbeno].im_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_il_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "il ");
	birlestir(suj, kok, tablo[verbeno].im_il_ara, ek, cekim->kisiler[2]);
	
	KokBul(verbe, tablo[verbeno].im_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_il_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "elle ");
	birlestir(suj, kok, tablo[verbeno].im_il_ara, ek, cekim->kisiler[3]);
			
                        /* nous */
	KokBul(verbe, tablo[verbeno].im_nous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_nous_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "nous ");
	birlestir(suj, kok, tablo[verbeno].im_nous_ara, ek, cekim->kisiler[4]);
	    
              /* vous */
	KokBul(verbe, tablo[verbeno].im_vous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_vous_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "vous ");
	birlestir(suj, kok, tablo[verbeno].im_vous_ara, ek, cekim->kisiler[5]);
	    
              /* ils elles*/
	KokBul(verbe, tablo[verbeno].im_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_ils_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "ils ");
	birlestir(suj, kok, tablo[verbeno].im_ils_ara, ek, cekim->kisiler[6]);
    
	KokBul(verbe, tablo[verbeno].im_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].im_ils_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "elles ");
	birlestir(suj, kok, tablo[verbeno].im_ils_ara, ek, cekim->kisiler[7]);
	
	return 1;
}

int FSimple(char *verbe, struct cekim_struct *cekim)
{
    char suj[10], kok[MAXSTR], ek[MAXSTR], ara[MAXSTR];
	int verbeno=-1;
	
    //cekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

	// Future simple'de kok ve ara'lar ayni.
	KokBul(verbe, tablo[verbeno].fs_tum_kok, kok);
	strcpy(ara, tablo[verbeno].fs_tum_ara);

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    	
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "je");
	birlestir(suj, kok, ara, ek, cekim->kisiler[0]);
        
	                    /* tu */
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "tu ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[1]);
	    
                        /* il elle*/
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "il ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[2]);
	
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "elle ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[3]);
			
                        /* nous */
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "nous ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[4]);
	    
              /* vous */
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "vous ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[5]);
	    
              /* ils elles*/
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "ils ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[6]);
    
	strcpy(ek, ekler[ tablo[verbeno].fs_tum_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "elles ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[7]);
	
	return 1;
}

int SPresent(char *verbe, struct cekim_struct *cekim)
{
    char suj[MAXSTR], kok[MAXSTR], ek[MAXSTR];
	int verbeno=-1;
	
    //ekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    KokBul(verbe, tablo[verbeno].sp_je_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_je_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "que je");
	birlestir(suj, kok, tablo[verbeno].sp_je_ara, ek, cekim->kisiler[0]);
	
	                    /* tu */
	KokBul(verbe, tablo[verbeno].sp_tu_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_tu_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "que tu ");
	birlestir(suj, kok, tablo[verbeno].sp_tu_ara, ek, cekim->kisiler[1]);
		    
                        /* il elle*/
	KokBul(verbe, tablo[verbeno].sp_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_il_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "qu'il ");
	birlestir(suj, kok, tablo[verbeno].sp_il_ara, ek, cekim->kisiler[2]);

	KokBul(verbe, tablo[verbeno].sp_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_il_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "qu'elle ");
	birlestir(suj, kok, tablo[verbeno].sp_il_ara, ek, cekim->kisiler[3]);
		
                        /* nous */
	KokBul(verbe, tablo[verbeno].sp_nous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_nous_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "que nous ");
	birlestir(suj, kok, tablo[verbeno].sp_nous_ara, ek, cekim->kisiler[4]);
    
              /* vous */
	KokBul(verbe, tablo[verbeno].sp_vous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_vous_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "que vous ");
	birlestir(suj, kok, tablo[verbeno].sp_vous_ara, ek, cekim->kisiler[5]);
    
              /* ils elles*/
	KokBul(verbe, tablo[verbeno].sp_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_ils_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "qu'ils ");
	birlestir(suj, kok, tablo[verbeno].sp_ils_ara, ek, cekim->kisiler[6]);
    
	KokBul(verbe, tablo[verbeno].sp_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].sp_ils_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "qu'elles ");
	birlestir(suj, kok, tablo[verbeno].sp_ils_ara, ek, cekim->kisiler[7]);
	
	return 1;
}

int CPresent(char *verbe, struct cekim_struct *cekim)
{
    char suj[10], kok[MAXSTR], ek[MAXSTR], ara[MAXSTR];
	int verbeno=-1;
	
    //ekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

	// Future simple'de kok ve ara'lar ayni.
	KokBul(verbe, tablo[verbeno].cp_tum_kok, kok);
	strcpy(ara, tablo[verbeno].cp_tum_ara);

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    	
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "je");
	birlestir(suj, kok, ara, ek, cekim->kisiler[0]);
        
	                    /* tu */
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "tu ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[1]);
	    
                        /* il elle*/
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "il ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[2]);
	
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "elle ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[3]);
			
                        /* nous */
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "nous ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[4]);
	    
              /* vous */
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "vous ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[5]);
	    
              /* ils elles*/
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "ils ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[6]);
    
	strcpy(ek, ekler[ tablo[verbeno].cp_tum_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "elles ");
	birlestir(suj, kok, ara, ek, cekim->kisiler[7]);
	
	return 1;
}

int Imperatif(char *verbe, struct cekim_struct *cekim)
{
    char suj[MAXSTR], kok[MAXSTR], ek[MAXSTR];
	int verbeno=-1, i;
	
    //ekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

	                    /* tu */
	KokBul(verbe, tablo[verbeno].ip_tu_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ip_tu_ek ].ek_tu);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "");
	birlestir(suj, kok, tablo[verbeno].ip_tu_ara, ek, cekim->kisiler[0]);
		    
                        /* nous */
	KokBul(verbe, tablo[verbeno].ip_nous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ip_nous_ek ].ek_nous);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "");
	birlestir(suj, kok, tablo[verbeno].ip_nous_ara, ek, cekim->kisiler[1]);
    
				  /* vous */
	KokBul(verbe, tablo[verbeno].ip_vous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ip_vous_ek ].ek_vous);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "");
	birlestir(suj, kok, tablo[verbeno].ip_vous_ara, ek, cekim->kisiler[2]);
    
	for(i=3; i<8; i++) cekim->ekler[2]=0;
	
	return 1;
}

int PSimple(char *verbe, struct cekim_struct *cekim)
{
    char suj[MAXSTR], kok[MAXSTR], ek[MAXSTR];
	int verbeno=-1;
	
    //ekilecek fiili tablo'da bul ve o numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

                        /* je */
	// Verilen verbe icin tablo'ya bakarak kok'u bul ve degeri kok'e kopyala.
    KokBul(verbe, tablo[verbeno].ps_je_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_je_ek ].ek_je);
	cekim->ekler[0]=strlen(ek); strcpy(suj, "je");
	birlestir(suj, kok, tablo[verbeno].ps_je_ara, ek, cekim->kisiler[0]);
	
	                    /* tu */
	KokBul(verbe, tablo[verbeno].ps_tu_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_tu_ek ].ek_tu);
	cekim->ekler[1]=strlen(ek); strcpy(suj, "tu ");
	birlestir(suj, kok, tablo[verbeno].ps_tu_ara, ek, cekim->kisiler[1]);
		    
                        /* il elle*/
	KokBul(verbe, tablo[verbeno].ps_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_il_ek ].ek_il);
	cekim->ekler[2]=strlen(ek); strcpy(suj, "il ");
	birlestir(suj, kok, tablo[verbeno].ps_il_ara, ek, cekim->kisiler[2]);

	KokBul(verbe, tablo[verbeno].ps_il_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_il_ek ].ek_il);
	cekim->ekler[3]=strlen(ek); strcpy(suj, "elle ");
	birlestir(suj, kok, tablo[verbeno].ps_il_ara, ek, cekim->kisiler[3]);
		
                        /* nous */
	KokBul(verbe, tablo[verbeno].ps_nous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_nous_ek ].ek_nous);
	cekim->ekler[4]=strlen(ek); strcpy(suj, "nous ");
	birlestir(suj, kok, tablo[verbeno].ps_nous_ara, ek, cekim->kisiler[4]);
    
              /* vous */
	KokBul(verbe, tablo[verbeno].ps_vous_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_vous_ek ].ek_vous);
	cekim->ekler[5]=strlen(ek); strcpy(suj, "vous ");
	birlestir(suj, kok, tablo[verbeno].ps_vous_ara, ek, cekim->kisiler[5]);
    
              /* ils elles*/
	KokBul(verbe, tablo[verbeno].ps_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_ils_ek ].ek_ils);
	cekim->ekler[6]=strlen(ek); strcpy(suj, "ils ");
	birlestir(suj, kok, tablo[verbeno].ps_ils_ara, ek, cekim->kisiler[6]);
    
	KokBul(verbe, tablo[verbeno].ps_ils_kok, kok);
	strcpy(ek, ekler[ tablo[verbeno].ps_ils_ek ].ek_ils);
	cekim->ekler[7]=strlen(ek); strcpy(suj, "elles ");
	birlestir(suj, kok, tablo[verbeno].ps_ils_ara, ek, cekim->kisiler[7]);
	
	return 1;
}


int PCompose(char *verbe, struct cekim_struct *cekim)
{
	struct cekim_struct auxiliare;
		
	Present("avoir", &auxiliare);
	
	TempsCompose(verbe, &auxiliare, cekim);
	return 1;
}

int PParfait(char *verbe, struct cekim_struct *cekim)
{
	struct cekim_struct auxiliare;
		
	Imparfait("avoir", &auxiliare);
	
	TempsCompose(verbe, &auxiliare, cekim);
	return 1;
}

int FAnterieur(char *verbe, struct cekim_struct *cekim)
{
	struct cekim_struct auxiliare;
		
	FSimple("avoir", &auxiliare);
	
	TempsCompose(verbe, &auxiliare, cekim);
	return 1;
}


int SPasse(char *verbe, struct cekim_struct *cekim)
{
	struct cekim_struct auxiliare;
		
	SPresent("avoir", &auxiliare);
	
	TempsCompose(verbe, &auxiliare, cekim);
	return 1;
}
int CPasse(char *verbe, struct cekim_struct *cekim)
{
	struct cekim_struct auxiliare;
		
	CPresent("avoir", &auxiliare);
	
	TempsCompose(verbe, &auxiliare, cekim);
	return 1;
}


int TempsCompose(char *verbe, struct cekim_struct *auxiliare, struct cekim_struct *cekim)
{
	char suj[MAXSTR], kok[MAXSTR], ara[MAXSTR];
	int verbeno=-1, i, uzek;
			
    //ekilecek fiili tablo'da bul ve numarasini getir.
    verbeno=CekimBul(verbe);
	if( verbeno==-1 ) {
		printf("Ce ne peut pas etre un verbe Francais verbeno=%d\n", verbeno);
		return 0; // false geldiyse ekim bulanamadi; geri dn.
	}

	// Temps Compose'de kok ve ara'lar ayni.
	KokBul(verbe, tablo[verbeno].pc_tum_kok, kok);
	strcpy(ara, tablo[verbeno].pc_tum_ara);
	// ek'e ihtiya yok
				
	/*je*/
	strcpy(suj, auxiliare->kisiler[0]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[0]);
	/*tu*/
	strcpy(suj, auxiliare->kisiler[1]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[1]);
    /*il*/
	strcpy(suj, auxiliare->kisiler[2]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[2]);
	/*elle*/
	strcpy(suj, auxiliare->kisiler[3]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[3]);
	/*nous*/
	strcpy(suj, auxiliare->kisiler[4]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[4]);
	/*vous*/
	strcpy(suj, auxiliare->kisiler[5]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[5]);
	/*ils*/
	strcpy(suj, auxiliare->kisiler[6]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[6]);
	/*elles*/
	strcpy(suj, auxiliare->kisiler[7]); strcat(suj, " ");
	birlestir(suj, kok, ara, "", cekim->kisiler[7]);

    uzek=strlen(kok)+strlen(ara);
    // ek uzunluklar participe passe'nin uzunluu
    for(i=0; i<8; i++) cekim->ekler[i]=uzek;
	return 1;
}


int KokBul( char *verbe, int sil, char *kok )
{
    int bas, verbe_uz;
	
	if( verbe==NULL ) return 0; // verbe yok hata olustu !
    strcpy(kok, verbe);
	verbe_uz = strlen(verbe);
	bas = verbe_uz - sil;
    if( sil >= verbe_uz ) kok[0]=(char)NULL;
	else kok[ verbe_uz-sil ] = (char)NULL;
    return 1;
}


int Kes(char *suj, char *kisi)
{
	int uz;	char sujson;
    char kes=kisi[0];

    uz=strlen(suj);
	sujson=suj[uz-1];
	if (sujson != 'e') return 1;
	if (kes=='h' || kes=='a' || kes=='o' || kes=='e' || kes=='' || kes==''|| kes=='i' || kes=='u') {
		suj[uz-1]=39;
		return 1;
	}
	strcat(suj, " ");
    return 1;
}

void birlestir(char *sujet, char *kok, char *ara, char *ek, char *kisi)
{
	char buf[MAXSTR];
	
	strcpy(buf, kok); strcat(buf, ara); strcat(buf, ek);
	Kes(sujet, buf);
	strcpy(kisi, sujet); strcat(kisi, buf);
}

int CekimBul(char *verbe)
{
    static char SonVerbe[MAXSTR]="yok";
    static int sonindex;

    int i, son, fiil_uz, index_sonuz=0, index=-1, verbe_uz=strlen(verbe);
    char fiil[MAXSTR], fiil_s[MAXSTR], verbe_s[MAXSTR];

    // Bir verbe iin, her zamann ekiminde buraya gelip
    // ekim tablosunda uygun yere gidiyor
    // Eger ayni verbe iin tekrar geldiyse; ekim tablosu
    // istenen yeri gsterdiginden geri dnmesi yeterli olur.
    if( !strcmp(verbe, SonVerbe) ) return sonindex;



    for(i=0; i<4; i++) {
        strcpy(fiil, tablo[i].fiil); fiil_uz=strlen(fiil);
        son=tablo[i].son;

        if( son <= verbe_uz ) { //verbe daha uzunsa
            // Tablodaki fiilin karsilastirilacak son kismini bul
            strcpy( fiil_s, &fiil[ fiil_uz - son ] );
			// Kullanicinin girdigi verbe'in karsilastirilacak son kismini bul
            strcpy( verbe_s, &verbe[verbe_uz - son] );
            // karsilastir, eger esitse while'dan ik
            if( !strcmp(verbe_s, fiil_s) & (son>index_sonuz ) ) {
				index=i; index_sonuz=son;
			}
        }
    }
	strcpy(SonVerbe, verbe); sonindex=index;
    return index;
}
